/*
 * gamelib.h: ɮxCclassinterface
 * Copyright (C) 2002 Woei-Kae Chen <wkc@csie.ntut.edu.tw>
 *
 * This file is part of game, a free game development platform for windows.
 *
 * game is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * game is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * History:
 *   2002-03-04 V3.1
 *		1. Add AUDIO_ENABLE flag.
 *   2004-03-02 V4.0
 *		1. Add CInteger class.
 *      2. Add CGameState abstract class and adjust CGame to apply
 *         state pattern for switching of game states.
 *   2004-03-08 V4.1
 *      1. Add OPEN_AS_FULLSCREEN flag.
 *      2. The Game Engine now becomes a framework.
 */

/////////////////////////////////////////////////////////////////////////////
// wqi]wCһP
/////////////////////////////////////////////////////////////////////////////

#define SIZE_X				640		// ]wCeѪR׬640x480
#define SIZE_Y				480		// (YϥμзǪѪRסAhù)
#define OPEN_AS_FULLSCREEN	false	// Hù覡}ҹC
#define AUDIO_ENABLE		true	// ҰʭĤ
#define GAME_CYCLE_TIME		33		// C33ms]@MoveShow(C30)

/////////////////////////////////////////////////////////////////////////////
// wqCGameCGameStateҨϥΪ`
/////////////////////////////////////////////////////////////////////////////

enum GAME_STATES {
	GAME_STATE_INIT,
	GAME_STATE_RUN,
	GAME_STATE_OVER
};

/////////////////////////////////////////////////////////////////////////////
// Header for STL (Standard Template Library)
/////////////////////////////////////////////////////////////////////////////

#include <list>
#include <vector>
using namespace std;

/////////////////////////////////////////////////////////////////////////////
// oclassѮɶB~
// @몺Cäݪާ@oӪA]iH޳oclassϥΤk
/////////////////////////////////////////////////////////////////////////////

class CSpecialEffect {
public:
	static void  SetCurrentTime();					// xsثeɶctime
	static DWORD GetEllipseTime();					// Ūثeɶ - ctime
	static int   GetCurrentTimeCount();				// Ūxsctime
	static void  Delay(DWORD ms);					//  x ms
	static void  DelayFromSetCurrentTime(DWORD ms);	// ctime_A x ms
	static void  Abort(char *s);					// oY~A{
private:
	static DWORD ctime;
	static int	 ctimeCount;
};

/////////////////////////////////////////////////////////////////////////////
// oclass|إDirectDrawAHѨLclassϥ
// @몺Cäݪާ@oӪA]iH޳oclassϥΤk
/////////////////////////////////////////////////////////////////////////////

class CDDraw {
	friend class CMovingBitmap;
public:
	~CDDraw();
	static void  BltBackColor(DWORD);		// NBack plainۤWwC
	static void  BltBackToPrimary();		// NBack plainKPrimary plain
	static CDC*  GetBackCDC();				// oBack PlainDC (device context)
	static void  GetClientRect(CRect &r);	// o]wѪR
	static void  Init(int, int);			// Initialize direct draw
	static void  ReleaseBackCDC();			// Back PlainDC (device context)
	static bool  SetFullScreen(bool);		// ]wùҦ/Ҧ
private:
	CDDraw();								// private constructor
	static void  BltBitmapToBack(int SurfaceID, int x, int y);
	static void  BltBitmapToBitmap(int SourceID, int TargetID, int x, int y);
	static void	 CheckDDFail(char *s);
	static void	 CheckSystem(int,int);
	static bool  CreateSurface();
	static bool  CreateSurfaceFullScreen();
	static bool  CreateSurfaceWindowed();
	static void  LoadBitmap(int i, int IDB_BITMAP);
	static DWORD MatchColorKey(LPDIRECTDRAWSURFACE lpDDSurface, COLORREF color);
	static int   RegisterBitmap(int IDB_BITMAP, COLORREF ColorKey);
	static void  ReleaseSurface();
	static void  RestoreSurface();
	static void  SetColorKey(int SurfaceID, COLORREF color);
    static HDC					hdc;
	static CDC					cdc;
	static CView				*pCView;
    static LPDIRECTDRAW2		lpDD;
	static LPDIRECTDRAWCLIPPER	lpClipperPrimary;   
	static LPDIRECTDRAWCLIPPER	lpClipperBack;   
	static LPDIRECTDRAWSURFACE	lpDDSPrimary;
	static LPDIRECTDRAWSURFACE	lpDDSBack;
	static vector<LPDIRECTDRAWSURFACE>	lpDDS;
    static HRESULT				ddrval;
	static vector<int>			BitmapID;
	static vector<CRect>		BitmapRect;
	static vector<COLORREF>		BitmapColorKey;
	static bool					fullscreen;
	static CDDraw				ddraw;
	static int					size_x, size_y;
};

/////////////////////////////////////////////////////////////////////////////
// oclassѰʺA(iH)ϧ
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CMovingBitmap {
public:
	CRect GetLocation();				// oϧΦbùWy
	int   Height();						// oϧΪ
	int   Left();						// oϧΪW x y
	void  LoadBitmap(int,int,int,COLORREF=CLR_INVALID);
										// ]wϪȡGϪsByСBγz
	void  SetTopLeft(int,int);			// NϪWyв (x,y)
	void  ShowBitmap();					// N϶K Back Plain
	void  ShowBitmap(CMovingBitmap &);	// N϶Kt@iϤW
	int   Top();						// oϧΪW y y
	int   Width();						// oϧΪe
protected:
	int SurfaceID;
	CRect location;
};

/////////////////////////////////////////////////////////////////////////////
// oclass|إDirectX AudioAHѭ
// CPublic InterfaceΪknAImplementationiH
// `NƶGɮץiHWAVE(.wav)MIDI(.mid)AƭӭɮץiH
//           VX(P)AO䤤uVX@MIDIɡAMIDIɮפ
//           PɼApGPɼMIDIɪܡAe@MIDIɷ|Q
//           C
/////////////////////////////////////////////////////////////////////////////

class CAudio {
public:
	~CAudio();
	void           Close();					// Direct Sound
	static CAudio *Instance();				// oCAudioInstance
	bool           Load(int, char *);		// JsinAwMIDIɮ
	bool           Open();					// }Direct Sound
	void		   Pause();					// ȰҦ
	void           Play(int, bool=false);	// }lsinAwO_м
	void		   Resume();				// _Ȱ񪺭
	void           Stop(int);				// sin
private:
	CAudio();									// private constructor
	static CAudio					   audio;	// ۰destruct
	MUSIC_TIME		 				   GetTimeOffset(MUSIC_TIME,MUSIC_TIME,MUSIC_TIME,MUSIC_TIME,MUSIC_TIME,MUSIC_TIME,DWORD);
	IDirectMusicLoader8				   *g_pLoader;
	IDirectMusicPerformance8		   *g_pPerformance;
	vector<IDirectMusicSegment8 *>	   g_pSegment;
	vector<IDirectMusicSegmentState *> g_pSegmentState;
	vector<long>					   g_ResumePoint;
	vector<bool>					   g_isPaused;
	vector<bool>					   isMIDI;
};

/////////////////////////////////////////////////////////////////////////////
// oclassѥiHʪʵe
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CAnimation {
public:
	CAnimation(int=10);				// Constructor (w]WvC1/3@i)
	void  AddBitmap(int,int,int,COLORREF=CLR_INVALID);
									// W[@iϧΦܰʵe(ϪsByСBγz)
	CRect GetLocation();			// oʵebùWy
	int   Height();					// oʵe
	int   Left();					// oʵeW x y
	void  SetTopLeft(int,int);		// NʵeWyв (x,y)
	void  ShowBitmap();				// NʵeK Back Plain
	int   Top();					// oʵeW y y
	int   Width();					// oʵee
private:
	list<CMovingBitmap>				bmp;			// list of CMovingBitmap
	list<CMovingBitmap>::iterator	bmp_iter;		// list iterator
	int								delay_counter;	// pƾ(wʵet)
	const int						DELAY_COUNT;	// ]wʵetת`
	int								x, y;			// ʵey
};

/////////////////////////////////////////////////////////////////////////////
// oclassܾƹϧΪO
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CInteger {
public:
	CInteger(int=5);				// default 5 digits
	void        Add(int n);			// W[ƭ
	int         GetInteger();		// ^Ǿƭ
	static void LoadBitmap();		// J0..9έtϧ
	void        SetInteger(int);	// ]wƭ
	void        SetTopLeft(int,int);// NʵeWyв (x,y)
	void        ShowBitmap();		// NʵeK Back Plain
private:
	const int NUMDIGITS;			// @NUMDIGITSӦ
	static CMovingBitmap digit[11]; // xs0..9έtϧ(bitmap)
	int x, y;						// ܪy
	int n;							// ƭ
};

/////////////////////////////////////////////////////////////////////////////
// ŧi|wqclass
/////////////////////////////////////////////////////////////////////////////

class CGame;
class CGameStateInit;
class CGameStateRun;
class CGameStateOver;

/////////////////////////////////////////////////////////////////////////////
// oclassCUتABase class(O@abstract class)
// CPublic InterfaceΪknAImplementationiH
/////////////////////////////////////////////////////////////////////////////

class CGameState {
public:
	CGameState(CGame *g);
	virtual ~CGameState() {}								// virtual destructor
	virtual void Move() {}									// ʳoӪAC
	virtual void OnBeginState() {}							// ]wCiJoӪAɩһݪ
	virtual void OnInitialUpdate() {}						// AȤιϧγ]w
	virtual void OnKeyDown(UINT, UINT, UINT) {}				// BzLDownʧ@
	virtual void OnKeyUp(UINT, UINT, UINT) {}				// BzLUpʧ@
	virtual void OnLButtonDown(UINT nFlags, CPoint point) {}// Bzƹʧ@
	virtual void OnLButtonUp(UINT nFlags, CPoint point) {}	// Bzƹʧ@
	virtual void OnRButtonDown(UINT nFlags, CPoint point) {}// Bzƹʧ@
	virtual void OnRButtonUp(UINT nFlags, CPoint point) {}	// Bzƹʧ@
	virtual void Show() = 0;								// ܳoӪACe
protected:
	void GotoGameState(int);
	CGame *game;
};

/////////////////////////////////////////////////////////////////////////////
// oclassOC֤ߡACi
// @몺Cäݪާ@oӪA]iH޳oclassϥΤk
/////////////////////////////////////////////////////////////////////////////

class CGame {
public:
	CGame();										// Constructor
	~CGame();										// Destructor
	bool IsRunning();								// ŪCO_bi椤
	void OnDraw();									// CGameViewOnDraw()
	void OnFilePause();								// CȰ
	void OnInitialUpdate();							// CȤιϧγ]w
	bool OnIdle();									// CDj
	void OnKeyDown(UINT, UINT, UINT);				// BzLDownʧ@
	void OnKeyUp(UINT, UINT, UINT);					// BzLUpʧ@
	void OnKillFocus();								// CQȰ
	void OnLButtonDown(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnLButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnRButtonDown(UINT nFlags, CPoint point);	// Bzƹʧ@
	void OnRButtonUp(UINT nFlags, CPoint point);	// Bzƹʧ@
	void SetGameState(int);
private:
	void Move();									// ʹC
	void Show();									// ܹCe
	bool			running;			// CO_bi椤(QPause)
	const int		NUM_GAME_STATES;	// CA(3ӪA)
	CGameState		*gameState;			// pointerVثeCA
	CGameState		*gameStateTable[3];	// CApointer
};
